package adminkindboxreqhandler

import (
	"net/http"
	"strconv"

	paginationparam "git.gocasts.ir/ebhomengo/niki/param"
	param "git.gocasts.ir/ebhomengo/niki/param/admin/kind_box_req"
	httpmsg "git.gocasts.ir/ebhomengo/niki/pkg/http_msg"
	echo "github.com/labstack/echo/v4"
)

func (h Handler) GetAll(c echo.Context) error {
	var req param.KindBoxReqGetAllRequest
	if bErr := c.Bind(&req); bErr != nil {
		return echo.NewHTTPError(http.StatusBadRequest)
	}

	var paginationReq paginationparam.PaginationRequest
	// TODO : pkg convert string to uint
	//nolint
	pageNumber, _ := strconv.ParseUint(c.QueryParam("page_number"), 0, 64)
	//nolint
	pageSize, _ := strconv.ParseUint(c.QueryParam("page_size"), 0, 64)
	paginationReq.PageSize = uint(pageSize)
	paginationReq.PageNumber = uint(pageNumber)

	resp, sErr := h.adminKindBoxReqSvc.GetAll(c.Request().Context(), req, paginationReq)
	if sErr != nil {
		msg, code := httpmsg.Error(sErr)

		return echo.NewHTTPError(code, msg)
	}

	return c.JSON(http.StatusCreated, resp)
}
